/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "SEMod_struct.h"
#include "SEPin.h"
#include <assert.h>
#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
#include <errno.h>     /* for EINVAL */
#include <sys\stat.h>  /* for _S_IWRITE */

#include <stdio.h> // files
#include <io.h> // filelenght ..

#include <string.h>
#include <process.h>
#include <wchar.h>



void Module::sub_process(long buffer_offset, long sampleFrames )
{  
	//float *in1    = buffer_offset + input1_buffer;
    float *in1   = buffer_offset + input1_buffer;
    float *in2   = buffer_offset + input2_buffer;
	float *in3   = buffer_offset + input3_buffer;
	float *out1  = buffer_offset + output1_buffer;
	
    // float *out   = buffer_offset + output1_buffer;
    while(--sampleFrames >= 0) // sampleFrames = how many samples to process (can vary). repeat (loop) that many times
    {
		               
        if ((*in1 > 0.2)&&(last_take > 0)) PLAY = true; else PLAY = false;
		if ( *in2 > 0.2) // STOP
		{
			taki = 0;
            got_one = false;
			PLAY    = false;
		}
		
		
		if(PLAY)
		{
		  if((taki == 0)&&(got_one == false)) start_time = SampleClock(); // nur anfang oder bei pause-switch
           
		  if(waspause == true)
		  {
		    pause_time = SampleClock() - pause_time;

			start_time += pause_time;
			waspause = false;
		  }


	      if((got_one == false)&&(taki <= last_take))
	      {
           time1 = tak_time[taki] + start_time;
	       midi  = tak_midi[taki];
           if((midi & 0xf0) == NOTE_ON) 
		   {
			   memDuration = 0.35f + *in3 * 0.01f * (float) (tak_lang[taki] >> 6);
               sprintf_s(text,400,"time float = %f \n", memDuration);
	           diag(text);

		   }
	       got_one = true;
	      }

	      if(got_one == true)
	      {
           

	       if(SampleClock() >= time1)
	       {
            
			*out1       = memDuration;
			
		    getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi);
		    taki++; got_one = false;
	       }
		  }
		}
		else //PAUSE
		{
		  if(waspause == false) 
		  {
			  pause_time = SampleClock();
			  waspause = true;
		  }
		}
        if(loop == 1){if (taki > last_take) taki = 0; }


        *out1 = memDuration;

		// increment the pointers (move to next sample in buffers)
		
		in1++;
		in2++;
		in3++;

		out1++;
    }

 
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
	
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{ 
	

 err = -1;
 err0 = -1;
 err2 = -1;

smidi_rec_file  = NULL;
smidi_play_file  = NULL;
textfile = NULL;
stream = NULL;

bool isnew = false;
bool isnew0 = false;
bool didonce = false;
int done = 0;



    got_one = false;
	canload = false;

	done = 0;got_one = false;

	SEModule_base::open();
  
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
	_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
    LL dish;
    sprintf_s(dish.thisSEM   ,100, "%s\n", "SMIDI_PLAY_DURATION_M\0" );
	properties->name = dish.thisSEM;	// this is the name the end-user will see
	properties->id = dish.thisSEM;

   int f = 1400;
   int j;
   BB bish;
   j  = sprintf_s(  bish.buffer    ,f, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " *      PLAYER for SMIDI Files       " );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,f, "%s\n", " ************************************" );//= 380 chars

	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";

	return true;
 
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	
	
	case 0:
		properties->name				= "PLAY";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 1:
		properties->name				= "STOP";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
	case 2:
        properties->name				= "DURATION_FACTOR";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "1";
        properties->datatype_extra      = "100,0.001,100,0.001";
		break;
	case 3:	
		properties->name                = "SMIDI_PLAYFILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="smidi"; // file extension
        break;
	case 4:
		properties->name				= "loopit";
		properties->variable_address	= &loop;
		properties->datatype_extra		= "range 0,1";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 5:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
	case 6:
        properties->name				= "DURATION";
		properties->variable_address	= &output1_buffer;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 7:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
	
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
	if(admin)
	{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
	}
}

void Module::OnPlugStateChange(SEPin *pin)
{
    in_stat = getPin(PN_TEXT)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	CallHost(seaudioMasterResolveFilename,PN_TEXT, MAX_FILENAME_LENGTH, (void *) full_path );
    //sprintf_s(text,400,"stat= %d \n",in_stat);
    //if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    sprintf_s(text,400,"%s\n",full_path);diag(text);
	
    //sprintf_s(text,400,"text_input= %s \n", text_input);
	//if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    wcscpy_s((wchar_t *)&smidi_play_name,strlen(full_path),(wchar_t *)&full_path);// copy name
    canload = true;
	loadarray();
	makelang();
    // err0 =  fopen_s(&smidi_play_file, smidi_play_name,"rb");
	isnew0 = true;
	}// here we got new path if !


/*
    state_type out_stat = ST_STATIC;
	for (int i = 1; i <= 3; i++)
	{
	 in_stat = getPin(i)->getStatus();
	 if( in_stat > ST_STATIC ) 
	         {
				 out_stat = ST_RUN; 
				 break;
	         }
	}
*/

	// 'transmit' new output status to next module 'downstream'
 getPin(PN_DURATION)->TransmitStatusChange( SampleClock(), ST_RUN);// statt out_stat ralph
}


void Module::loadarray()
{ 
	 
      fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ! r+b mode read+binary

      int filehandle = _fileno(stream);
      flang = _filelength(filehandle);
	  flang = flang / (sizeof(unsigned long) * 2);
      flang++;

      sprintf_s(text,400,"_fileno flang = %d \n", flang);
	  diag(text);
      

      //fclose(stream);// THAT WAS THE MIDIFILE 

      PLAY = false;
      if(tak_time != NULL) delete [] tak_time;                // delete if used before
      if(tak_midi != NULL) delete [] tak_midi;
     
      tak_time = new unsigned long [flang];         // resize ARRAY reset ARRAYINDEX
      tak_midi = new unsigned long [flang];

	  
      //if(stream) fclose (stream);

      //fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ?rb
	  taki = 0; 
      while(! feof(stream))
      {
               fread(&pc,sizeof(unsigned long ),1,stream);        // TIME_pc_clock
      tak_time[taki]= pc;
               fread(&md,sizeof(unsigned long ),1,stream);        // MIDI_msg
      tak_midi[taki]= md;
                    taki++;                                      // next two    
	  }
	  
      fclose(stream);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
          taki = 0; pause_time = 0;

      sprintf_s(text,400,"last_take= %d \n", last_take); diag(text);

}

void Module::makelang()
{
  if(tak_lang != NULL) delete [] tak_lang;
     tak_lang = new unsigned long [flang];
     int chan1, chan2 , stat1, stat2;
	 unsigned long midi1,midi2;
	 unsigned long time1;//,time2;
     for (unsigned long i = 0; i < last_take; i++)
	 {
		 midi1 = tak_midi[i];
		 stat1 = midi1 & 0xf0;
		 if(stat1 == NOTE_ON)
		 {
		  time1 = tak_time[i];
          chan1 = midi1 & 0x0f;
          for(unsigned long j = 1; j <= (last_take - i); j++)
		  {
		   midi2 = tak_midi[i+j];
		   stat2 = midi2 & 0xf0;
		   if(stat2 == NOTE_OFF)
		   {
            chan2 = midi2 & 0x0f;
			if(chan2 == chan1)// = NOTE_OFF von NOTE_ON im selben CHANNEL
			{
			 tak_lang[i] = tak_time[i+j]-time1; // ZEIT_DIFFERENZ
             duration =  0.35f +  0.01f * (float) (tak_lang[i] >> 6);
			 
             sprintf_s(text,400,"timediff = %d | %f\n", tak_lang[i],duration);
	         diag(text);


			 break; // inner for j ...
			}
		   }
		  }
		 }
	 
	 }
}
/*
        int chan = midi_msg & 0x0f;
		int stat = midi_msg & 0xf0;

		// the next two bytes depend on the type of message
		int b2 = ( midi_msg / 0x100 ) & 0xff;   // NOTEPITCH
		int b3 = ( midi_msg / 0x10000 ) & 0xff; // NOTEVEL

		switch( stat )
		{
		case NOTE_ON:
		case NOTE_OFF:
			{
				b2 += transpose_ammount; // byte 2 is the note number
				if( b2 > 127 )
					b2 = 127;
				if( b2 < 0 )
					b2 = 0;
			}

			// re-assemble the MIDI message into an 32 bit integer
			midi_msg = stat + chan + (b2 << 8) + (b3 << 16);
			break;
		}


*/


